#pragma once
#include "Human.h"
#include "Deck.h"
#include "Player.h"
#include <vector>
#include <array>

class Dealer : public Human {
private: 
	bool m_license;
	std::array<Card*, 2> m_hand;
public:
	Dealer() = delete;
	Dealer(std::string name, int age);
	Dealer(std::string name, int age, bool license);
	Dealer(std::string name, int age, bool license, std::string homecity);
	Dealer(const Dealer& dealer);
	~Dealer();

	bool GetLicense() const;
	void InvokeLicense();
	void DealCards(Deck& deck, std::vector<Player*> players);
	void AddCard(Card* card);
	void ShowHand() const;
	void ShowCard() const;
	bool IsBlackjack() const;

	Card* DrawCard(Deck& deck);
};