#pragma once
#include <iostream>
#include "Dealer.h"
#include "Player.h"
#include "Deck.h"

#include <vector>

#define AGE_LIMIT 21

class Game {
private:
	std::string m_name;
	int m_player_amount;
	Dealer* m_dealer;
	// TODO: perhaps can have multiple decks?
	Deck* m_deck;
	std::vector<Player*> m_players;
public:
	Game() = delete;
	Game(std::string name, int player_amout);
	Game(std::string name, int player_amout, Dealer *dealer);
	~Game();

	void AddDealer(Dealer* dealer);
	bool AddPlayer(Player* player);
	void AddDeck(Deck* deck);
	void PrintGameInfo() const;
	void Start();
	void ShuffleTheDeck();
	void StartRound();
	void PlaceBets();
	void ShowHands() const;
	void DealerWon();
	void PlayerWon(Player* player);
};