#include "Player.h"
#include <iostream>

// Constructors
Player::Player(std::string name, int age) : Player(name, age, "") {}
Player::Player(std::string name, int age, std::string homecity) : Human(name, age, homecity) {
	m_bet = 0;
	m_hand = {nullptr, nullptr};
}

// Copy constructor
Player::Player(const Player& player) : Human(player) {
	m_bet = 0;
	m_hand = { nullptr, nullptr };
}

// Destructor
Player::~Player() {
	std::cout << "player destroyed!" << std::endl;
}

// Saves the bet information on player
void Player::SetBet(int bet) {
	m_bet = bet;
}

/// <summary>
/// Checks if the player has a blackjack (21) in hand
/// </summary>
/// <returns></returns>
bool Player::IsBlackjack() const {
	int amount{ 0 };
	if (m_hand[0]->GetNumber() == 1 && m_hand[1]->GetNumber() >= 10) return true;
	else if (m_hand[1]->GetNumber() == 1 && m_hand[0]->GetNumber() >= 10) return true;
	return false;
}

/// <summary>
/// Prints the players hand
/// </summary>
void Player::ShowHand() const {
	std::cout << "Player " << m_name << "'s hand is : " << std::endl;
	m_hand[0]->ToString();
	m_hand[1]->ToString();
	std::cout << std::endl;
}


/// <summary>
/// Add the given card to the players hand
/// COUT a message if hand is full
/// </summary>
/// <param name="card"></param>
void Player::AddCard(Card* card) {
	try {
		if (m_hand[0] == nullptr) m_hand[0] = card;
		else if (m_hand[1] == nullptr) m_hand[1] = card;
		else throw(m_name);
	}
	catch (std::string name) {
		std::cout << "CAN'T ADD A CARD TO PLAYER " << name << "'s HAND SINCE IT'S FULL!";
	}
}